<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>Game of Life</title>
  </head>
  <body>
    <div id="world">
    </div>
  <script>
    const world = document.querySelector("#world");
    const parser = new DOMParser();
    
    document.addEventListener("DOMContentLoaded", (event) => startLifeCycle());

    function startLifeCycle() {
        console.log("start life cycle");

        let timerId = setInterval(() => fetchNextWorldFromServer(), 500);
        setTimeout(() => clearInterval(timerId), 100_000);
    }

    function fetchNextWorldFromServer() {
        fetch("next_world")
            .then((response) => {
                if (!response.ok) {
                    throw new Error(`HTTP error: ${response.status}`);
                }
                return response.text();
            })
            .then((text) => {
                world.childNodes.forEach(child => child.remove());
                let parsedTableDocument = parser.parseFromString(text, 'text/html');
                world.append(parsedTableDocument.body);
            })
            .catch((error) => (world.textContent = `Could not fetch the next world: ${error}`));
    }
  </script>
  </body>
</html>